
/* Copyright (C) 2001 John Price <linux-guru@gcfl.net>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA. */

#ifndef _RS232_H_
#define _RS232_H_

#include "gendef.h"
#include <msp430x14x.h>
#include "board_config.h"

#define UART_TRANSMITTING   0x01
#define UART_RX_OVERFLOW    0x02

// function to initialize UART(s)
void UART_Initialize(void);

#ifdef USE_UART0
extern uint8 uart0_flags;

bool UART0_RXready(void);
char UART0_getchar(void);
char UART0_putchar(char c);
void UART0_putstring(char *s);

#ifdef UART0_INT_DRIVEN
void UART0_ClearTxBuffer(void);
void UART0_ClearRxBuffer(void);

bool UART0_TxBufferEmpty(void);
bool UART0_RxBufferEmpty(void);

bool UART0_TxBufferFull(void);
bool UART0_RxBufferFull(void);
#endif
#endif //USE_UART0


#ifdef USE_UART1
extern uint8 uart1_flags;

bool UART1_RXready(void);
char UART1_getchar(void);
char UART1_putchar(char c);
void UART1_putstring(char *s);

#ifdef UART1_INT_DRIVEN
void UART1_ClearTxBuffer(void);
void UART1_ClearRxBuffer(void);

bool UART1_TxBufferEmpty(void);
bool UART1_RxBufferEmpty(void);

bool UART1_TxBufferFull(void);
bool UART1_RxBufferFull(void);
#endif //UART1_INT_DRIVEN
#endif //USE_UART1

#endif //_RS232_H_
